<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="设备ID" prop="deviceId">
        <el-input v-model="formData.deviceId" placeholder="请输入设备ID" />
      </el-form-item>
      <el-form-item label="使用寿命(月)" prop="serviceLife">
        <el-input v-model="formData.serviceLife" placeholder="请输入使用寿命(月)" />
      </el-form-item>
      <el-form-item label="折旧方法" prop="depreciationMethod">
        <el-input v-model="formData.depreciationMethod" placeholder="请输入折旧方法" />
      </el-form-item>
      <el-form-item label="原值" prop="originalValue">
        <el-input v-model="formData.originalValue" placeholder="请输入原值" />
      </el-form-item>
      <el-form-item label="净值" prop="netValue">
        <el-input v-model="formData.netValue" placeholder="请输入净值" />
      </el-form-item>
      <el-form-item label="净残率(%)" prop="residualRate">
        <el-input v-model="formData.residualRate" placeholder="请输入净残率(%)" />
      </el-form-item>
      <el-form-item label="月折旧额" prop="monthlyDepreciation">
        <el-input v-model="formData.monthlyDepreciation" placeholder="请输入月折旧额" />
      </el-form-item>
      <el-form-item label="开始折旧月(YYYY-MM)" prop="startDepreciationMonth">
        <el-input v-model="formData.startDepreciationMonth" placeholder="请输入开始折旧月(YYYY-MM)" />
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { DepreciationApi, Depreciation } from '@/api/device/depreciation'

/** 设备折旧信息 表单 */
defineOptions({ name: 'DepreciationForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  deviceId: undefined,
  serviceLife: undefined,
  depreciationMethod: undefined,
  originalValue: undefined,
  netValue: undefined,
  residualRate: undefined,
  monthlyDepreciation: undefined,
  startDepreciationMonth: undefined,
  remark: undefined,
})
const formRules = reactive({
  deviceId: [{ required: true, message: '设备ID不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await DepreciationApi.getDepreciation(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as Depreciation
    if (formType.value === 'create') {
      await DepreciationApi.createDepreciation(data)
      message.success(t('common.createSuccess'))
    } else {
      await DepreciationApi.updateDepreciation(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    deviceId: undefined,
    serviceLife: undefined,
    depreciationMethod: undefined,
    originalValue: undefined,
    netValue: undefined,
    residualRate: undefined,
    monthlyDepreciation: undefined,
    startDepreciationMonth: undefined,
    remark: undefined,
  }
  formRef.value?.resetFields()
}
</script>